namespace Smoll
{
    public class Component : IActionable
    {
        internal Entity? owner;
        private int zOrderImpl = 0;
        public int zOrder{get{ return zOrderImpl;} set{zOrderImpl = value; if(owner != null) owner.actionables.Sort();}} 

        public Entity GetEntity() {
            return owner;
        }

        public virtual void OnAttached() {}

        public virtual void Update(float deltaTimeSeconds) {}
        public virtual void Draw(Layer.DrawMode drawMode) {}
    }
}